| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions
Tp::Client::CallContentInterfaceMediaInterface Class Reference

`#include <TelepathyQt/CallContent>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply UpdateLocalMediaDescription (const QVariantMap &mediaDescription, int timeout=-1)
- QDBusPendingReply AcknowledgeDTMFChange (uchar event, uint state, int timeout=-1)
- QDBusPendingReply Fail (const Tp::CallStateReason &reason, int timeout=-1)

## Signals

- void NewMediaDescriptionOffer (const QDBusObjectPath &mediaDescription, const QVariantMap &properties)
- void MediaDescriptionOfferDone ()
- void LocalMediaDescriptionChanged (const QVariantMap &updatedMediaDescription)
- void RemoteMediaDescriptionsChanged (const Tp::ContactMediaDescriptionPropertiesMap &updatedMediaDescriptions)
- void MediaDescriptionsRemoved (const Tp::UIntList &removedMediaDescriptions)
- void DTMFChangeRequested (uchar event, uint state)

## Public Member Functions

- CallContentInterfaceMediaInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- CallContentInterfaceMediaInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- CallContentInterfaceMediaInterface (Tp::DBusProxy *proxy)
- CallContentInterfaceMediaInterface (const Tp::Client::CallContentInterface &mainInterface)
- CallContentInterfaceMediaInterface (const Tp::Client::CallContentInterface &mainInterface, QObject *parent)
- Tp::PendingVariant * requestPropertyRemoteMediaDescriptions () const
- Tp::PendingVariant * requestPropertyLocalMediaDescriptions () const
- Tp::PendingVariant * requestPropertyMediaDescriptionOffer () const
- Tp::PendingVariant * requestPropertyPacketization () const
- Tp::PendingVariant * requestPropertyCurrentDTMFEvent () const
- Tp::PendingVariant * requestPropertyCurrentDTMFState () const
- Tp::PendingVariantMap * requestAllProperties () const

## Static Public Member Functions

- static QLatin1String staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Call1.Content.Interface.Media".

## Constructor & Destructor Documentation

Tp::Client::CallContentInterfaceMediaInterface::CallContentInterfaceMediaInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallContentInterfaceMediaInterface associated with the given object on the session bus.

Parameters:

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallContentInterfaceMediaInterface::CallContentInterfaceMediaInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallContentInterfaceMediaInterface associated with the given object on the given bus.

Parameters:

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallContentInterfaceMediaInterface::CallContentInterfaceMediaInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a CallContentInterfaceMediaInterface associated with the same object as the given proxy.

Parameters:

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::CallContentInterfaceMediaInterface::CallContentInterfaceMediaInterface | ( | const Tp::Client::CallContentInterface & | mainInterface | ) | `[explicit]`

Creates a CallContentInterfaceMediaInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters:

  mainInterface | The proxy to use.

Tp::Client::CallContentInterfaceMediaInterface::CallContentInterfaceMediaInterface | ( | const Tp::Client::CallContentInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a CallContentInterfaceMediaInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters:

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::CallContentInterfaceMediaInterface::staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Call1.Content.Interface.Media", which this class represents.

Returns:
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::CallContentInterfaceMediaInterface::requestPropertyRemoteMediaDescriptions | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `RemoteMediaDescriptions` of type `Tp::ContactMediaDescriptionPropertiesMap`.

A map from contact handles to descriptions supported by that contact. Keys of this map will appear in at most one RemoteMembers. See RemoteContact for more details on how to map between MediaDescriptions and Streams.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentInterfaceMediaInterface::requestPropertyLocalMediaDescriptions | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `LocalMediaDescriptions` of type `Tp::ContactMediaDescriptionPropertiesMap`.

A map from contact handles to the descriptions the local side responsed with.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentInterfaceMediaInterface::requestPropertyMediaDescriptionOffer | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `MediaDescriptionOffer` of type `Tp::MediaDescriptionOffer`.

The object path to the current CallContentMediaDescriptionInterface object, its CallContentMediaDescriptionInterface::RemoteContact and a mapping of the MediaDescriptions properties. If the object path is "/" then there isn't an outstanding content description, and the mapping MUST be empty.

Having all CallContentMediaDescriptionInterface properties here saves a D-Bus round-trip - it shouldn't be necessary to get these properties from the Content MediaDescription object, in practice.

Change notification is via the NewMediaDescriptionOffer() and MediaDescriptionOfferDone() signals.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentInterfaceMediaInterface::requestPropertyPacketization | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `Packetization` of type `uint`.

The packetization method in use for this content.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentInterfaceMediaInterface::requestPropertyCurrentDTMFEvent | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `CurrentDTMFEvent` of type `uchar`.

The currently requested DTMF event (for state-recoverability of DTMFChangeRequested). Should be ignored if CurrentDTMFState is None.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentInterfaceMediaInterface::requestPropertyCurrentDTMFState | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `CurrentDTMFState` of type `uint`.

The current DTMF state (for state-recoverability of DTMFChangeRequested).

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::CallContentInterfaceMediaInterface::requestAllProperties | ( |  | ) | const`[inline]`

Request all of the DBus properties on the interface.

Returns:
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply Tp::Client::CallContentInterfaceMediaInterface::UpdateLocalMediaDescription | ( | const QVariantMap & | mediaDescription,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `UpdateLocalMediaDescription` on the remote object.

Update the local codec mapping and other interfaces of the MediaDescription. This method should only be used during an existing call to update the local media description. This may trigger a re-negotiation which may result in new new MediaDescriptionOffers if the "FurtherNegotiationRequired" property is TRUE. Otherwise, only parameters which strictly describe the media being sent can be changed.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  mediaDescription | The updated media description that the local side wants to use.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallContentInterfaceMediaInterface::AcknowledgeDTMFChange | ( | uchar | event,
|  | uint | state,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `AcknowledgeDTMFChange` on the remote object.

Called by the streaming implementation in response to DTMFChangeRequested to confirm that it has started or stopped sending the event in question.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  event | The event referred to in the corresponding DTMFChangeRequested signal.
  state | Either Sending or None.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallContentInterfaceMediaInterface::Fail | ( | const Tp::CallStateReason & | reason,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `Fail` on the remote object.

Signal an unrecoverable error for this content, and remove it.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  reason | A reason struct describing the error.
  timeout | The timeout in milliseconds.

void Tp::Client::CallContentInterfaceMediaInterface::NewMediaDescriptionOffer | ( | const QDBusObjectPath & | mediaDescription,
|  | const QVariantMap & | properties
| ) |  | `[signal]`

Represents the signal `NewMediaDescriptionOffer` on the remote object.

Emitted when a new CallContentMediaDescriptionInterface appears. The streaming >implementation MUST respond by calling the CallContentMediaDescriptionInterface::Accept() or CallContentMediaDescriptionInterface::Reject() method on the description object appeared.

Emission of this signal indicates that the MediaDescriptionOffer property has changed to `(Description, Contact, MediaDescriptionProperties)`.

When the MediaDescriptionOffer has been dealt with then CallContentInterfaceMediaInterface::MediaDescriptionOfferDone() must be emitted before CallContentInterfaceMediaInterface::NewMediaDescriptionOffer() is emitted again.

Parameters:

  mediaDescription | The object path of the new media description. This replaces any previous media description.
  properties | The immutable properties of the remote media description. Having all the MediaDescription properties here saves a D-Bus round-trip - it shouldn't be necessary to get the properties from the MediaDescription object, in practice.

void Tp::Client::CallContentInterfaceMediaInterface::MediaDescriptionOfferDone | ( |  | ) | `[signal]`

Represents the signal `MediaDescriptionOfferDone` on the remote object.

Emitted when a CallContentMediaDescriptionInterface has been handled.

Emission of this signal indicates that the MediaDescriptionOffer property has changed to `("/", 0, {})`.

void Tp::Client::CallContentInterfaceMediaInterface::LocalMediaDescriptionChanged | ( | const QVariantMap & | updatedMediaDescription | ) | `[signal]`

Represents the signal `LocalMediaDescriptionChanged` on the remote object.

Change notification for CallContentInterfaceMediaInterface::LocalMediaDescriptions

Parameters:

  updatedMediaDescription | The local content description that was updated

void Tp::Client::CallContentInterfaceMediaInterface::RemoteMediaDescriptionsChanged | ( | const Tp::ContactMediaDescriptionPropertiesMap & | updatedMediaDescriptions | ) | `[signal]`

Represents the signal `RemoteMediaDescriptionsChanged` on the remote object.

Change notification for CallContentInterfaceMediaInterface::RemoteMediaDescriptions

Parameters:

  updatedMediaDescriptions | The remote content descriptions that were updated

void Tp::Client::CallContentInterfaceMediaInterface::MediaDescriptionsRemoved | ( | const Tp::UIntList & | removedMediaDescriptions | ) | `[signal]`

Represents the signal `MediaDescriptionsRemoved` on the remote object.

Removal notification for CallContentInterfaceMediaInterface::RemoteMediaDescriptions and CallContentInterfaceMediaInterface::LocalMediaDescriptions

Parameters:

  removedMediaDescriptions | The local and remote content descriptions that are no longer part of this content

void Tp::Client::CallContentInterfaceMediaInterface::DTMFChangeRequested | ( | uchar | event,
|  | uint | state
| ) |  | `[signal]`

Represents the signal `DTMFChangeRequested` on the remote object.

Used by the CM to relay instructions from Channel.Interface.DTMF to the streaming implementation. If any contact in this call supports the telephone-event codec in their MediaDescription, this event should be sent as outlined in RFC 4733. Otherwise, it should be sent as an audible tone.

Parameters:

  event | The event to send (or stop sending).
  state | Either Pending_Send or Pending_Stop_Sending.

void Tp::Client::CallContentInterfaceMediaInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  | `[protected, virtual]`

Reimplemented from Tp::AbstractInterface.